//  SettingsPowerController.m

#import "OutputPowerController.h"
#import "Utils.h"
#import <ASRP31N_SDK/ASRP31N_SDK.h>

#define DF_READTIME_MIN 10
#define DF_READTIME_MAX 2550

@interface OutputPowerController () <ASRP31NSDKDelegate>
{
    int maxPowerValue;
    int minPowerValue;
    
    int powerAnt1;
    int powerAnt2;
    int powerAnt3;
    int powerAnt4;
    int powerAnt5;
    int powerAnt6;
    int powerAnt7;
    int powerAnt8;
    
    
    int readTimeAnt1;
    int readTimeAnt2;
    int readTimeAnt3;
    int readTimeAnt4;
    int readTimeAnt5;
    int readTimeAnt6;
    int readTimeAnt7;
    int readTimeAnt8;
    
    NSMutableArray *arrPowerRange;
}

@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt1;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt2;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt3;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt4;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt5;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt6;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt7;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldReadTimeAnt8;

@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt1;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt2;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt3;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt4;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt5;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt6;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt7;
@property (nonatomic,retain) IBOutlet UITextField *txtFieldOutPwrAnt8;

-(IBAction)setOutputPowerButtonAction:(id)sender;
@end

@implementation OutputPowerController

//----------------------------------------------
#pragma mark - Lifecycle
//----------------------------------------------
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self.tableView reloadData];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    if(arrPowerRange == nil)
        arrPowerRange = [[NSMutableArray alloc]init];
    
    [arrPowerRange removeAllObjects];
    
    [ASRP31NSDK sharedInstance].delegate = self;
    
    [self performSelector:@selector(onTickGetOuputPower) withObject:nil afterDelay:.2f];
    [self performSelector:@selector(onTickGetReadTime) withObject:nil afterDelay:.4f];
    /*20190621  Response Time Out*/
    [Utils showLoadingView:@"Check Settings" timeOut:df_TIMEOUT_DEFAULT];
}

- (void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
    [ASRP31NSDK sharedInstance].delegate = nil;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

//----------------------------------------------
#pragma mark - IBAction
//----------------------------------------------
-(IBAction)setOutputPowerButtonAction:(id)sender
{
    [self updateTxValue];
    if([self checkInputValue]) {
        /*20190621  Response Time Out*/
        [Utils showLoadingView:@"Change OutputPower" timeOut:df_TIMEOUT_DEFAULT];
        NSError *error = [[ASRP31NSDK sharedInstance] setOutputPowerLevelAntenna1:powerAnt1
                                                                         Antenna2:powerAnt2
                                                                         Antenna3:powerAnt3
                                                                         Antenna4:powerAnt4
                                                                         Antenna5:powerAnt5
                                                                         Antenna6:powerAnt6
                                                                         Antenna7:powerAnt7
                                                                         Antenna8:powerAnt8];
        
        if( error ){
            NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
        }
    }
}

//----------------------------------------------
#pragma mark - PrivateMethod
//----------------------------------------------
-(void) onTickGetOuputPower
{
    NSError *error = [[ASRP31NSDK sharedInstance] getOutputPowerLevelForMultiAntenna];
    if( error ){
        NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
    }
}

-(void) onTickGetReadTime
{
    NSError *error = [[ASRP31NSDK sharedInstance] getReadTimeForMultiAntenna];
    if( error ){
        NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
    }
}

- (BOOL)checkInputValue
{
    NSString *errPowerMessage = [NSString stringWithFormat:@" Min %.1f MAX %.1f",(float)(minPowerValue/10.0),(float)(maxPowerValue/10.0)];
    
    NSString *errReadTimeMessage = [NSString stringWithFormat:@" Min %d MAX %d",DF_READTIME_MIN,DF_READTIME_MAX];
    
    BOOL isErrorPower = NO;
    if((powerAnt1<minPowerValue)||(powerAnt1>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt2<minPowerValue)||(powerAnt2>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt3<minPowerValue)||(powerAnt3>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt4<minPowerValue)||(powerAnt4>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt5<minPowerValue)||(powerAnt5>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt6<minPowerValue)||(powerAnt6>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt7<minPowerValue)||(powerAnt7>maxPowerValue))
        isErrorPower = YES;
    if((powerAnt8<minPowerValue)||(powerAnt8>maxPowerValue))
        isErrorPower = YES;
    
    BOOL isErrorReadtime = NO;
    if((readTimeAnt1<DF_READTIME_MIN)||(readTimeAnt1>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt2<DF_READTIME_MIN)||(readTimeAnt2>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt3<DF_READTIME_MIN)||(readTimeAnt3>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt4<DF_READTIME_MIN)||(readTimeAnt4>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt5<DF_READTIME_MIN)||(readTimeAnt5>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt6<DF_READTIME_MIN)||(readTimeAnt6>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt7<DF_READTIME_MIN)||(readTimeAnt7>DF_READTIME_MAX))
        isErrorReadtime = YES;
    if((readTimeAnt8<DF_READTIME_MIN)||(readTimeAnt8>DF_READTIME_MAX))
        isErrorReadtime = YES;
    
    if(isErrorPower)
        [Utils showAlert:@"Power Range value error" message:errPowerMessage view:self];
    
    if(isErrorReadtime)
        [Utils showAlert:@"Read Time Range value error" message:errReadTimeMessage view:self];
    
    if(!isErrorPower&&!isErrorReadtime)
        return YES;
    else
        return NO;
}

-(void)updateTxValue
{
    powerAnt1 = [[_txtFieldOutPwrAnt1 text]floatValue]*10;
    powerAnt2 = [[_txtFieldOutPwrAnt2 text]floatValue]*10;
    powerAnt3 = [[_txtFieldOutPwrAnt3 text]floatValue]*10;
    powerAnt4 = [[_txtFieldOutPwrAnt4 text]floatValue]*10;
    powerAnt5 = [[_txtFieldOutPwrAnt5 text]floatValue]*10;
    powerAnt6 = [[_txtFieldOutPwrAnt6 text]floatValue]*10;
    powerAnt7 = [[_txtFieldOutPwrAnt7 text]floatValue]*10;
    powerAnt8 = [[_txtFieldOutPwrAnt8 text]floatValue]*10;
    
    
    readTimeAnt1  = [[_txtFieldReadTimeAnt1 text]intValue];
    readTimeAnt2  = [[_txtFieldReadTimeAnt2 text]intValue];
    readTimeAnt3  = [[_txtFieldReadTimeAnt3 text]intValue];
    readTimeAnt4  = [[_txtFieldReadTimeAnt4 text]intValue];
    readTimeAnt5  = [[_txtFieldReadTimeAnt5 text]intValue];
    readTimeAnt6  = [[_txtFieldReadTimeAnt6 text]intValue];
    readTimeAnt7  = [[_txtFieldReadTimeAnt7 text]intValue];
    readTimeAnt8  = [[_txtFieldReadTimeAnt8 text]intValue];
}

-(void)updateValue
{
    [_txtFieldOutPwrAnt1 setText:[NSString stringWithFormat:@"%.1f",powerAnt1/10.0]];
    [_txtFieldOutPwrAnt2 setText:[NSString stringWithFormat:@"%.1f",powerAnt2/10.0]];
    [_txtFieldOutPwrAnt3 setText:[NSString stringWithFormat:@"%.1f",powerAnt3/10.0]];
    [_txtFieldOutPwrAnt4 setText:[NSString stringWithFormat:@"%.1f",powerAnt4/10.0]];
    [_txtFieldOutPwrAnt5 setText:[NSString stringWithFormat:@"%.1f",powerAnt5/10.0]];
    [_txtFieldOutPwrAnt6 setText:[NSString stringWithFormat:@"%.1f",powerAnt6/10.0]];
    [_txtFieldOutPwrAnt7 setText:[NSString stringWithFormat:@"%.1f",powerAnt7/10.0]];
    [_txtFieldOutPwrAnt8 setText:[NSString stringWithFormat:@"%.1f",powerAnt8/10.0]];
    
    
    [_txtFieldReadTimeAnt1 setText:[NSString stringWithFormat:@"%d",readTimeAnt1]];
    [_txtFieldReadTimeAnt2 setText:[NSString stringWithFormat:@"%d",readTimeAnt2]];
    [_txtFieldReadTimeAnt3 setText:[NSString stringWithFormat:@"%d",readTimeAnt3]];
    [_txtFieldReadTimeAnt4 setText:[NSString stringWithFormat:@"%d",readTimeAnt4]];
    [_txtFieldReadTimeAnt5 setText:[NSString stringWithFormat:@"%d",readTimeAnt5]];
    [_txtFieldReadTimeAnt6 setText:[NSString stringWithFormat:@"%d",readTimeAnt6]];
    [_txtFieldReadTimeAnt7 setText:[NSString stringWithFormat:@"%d",readTimeAnt7]];
    [_txtFieldReadTimeAnt8 setText:[NSString stringWithFormat:@"%d",readTimeAnt8]];
}
//----------------------------------------------
#pragma mark - ASRP31NSDK Delegate
//----------------------------------------------
- (void)ASRP31N:(ASRP31NSDK *)ASRP31N didSetOutputPowerLevelStatus:(ASRP31NSDKCommonStatus)statusCode
{
    switch (statusCode) {
        case ASRP31NSDKCommonStatusSuccess:
            [Utils showAlert:@"Success" message:@"Output Power changed" view:self];
            break;
            
        case ASRP31NSDKCommonStatusFailure:
            [Utils showAlert:@"Fail" message:@"Output Power changed" view:self];
            break;
        default:
            break;
    }
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedReadTimeAntenna1:(uint16_t)antenna1 Antenna2:(uint16_t)antenna2
                                                      Antenna3:(uint16_t)antenna3 Antenna4:(uint16_t)antenna4
                                                      Antenna5:(uint16_t)antenna5 Antenna6:(uint16_t)antenna6
                                                      Antenna7:(uint16_t)antenna7 Antenna8:(uint16_t)antenna8
{
    /*20190621  Response Time Out*/
    [Utils hiddenLoadingView];
    readTimeAnt1 = antenna1;
    readTimeAnt2 = antenna2;
    readTimeAnt3 = antenna3;
    readTimeAnt4 = antenna4;
    readTimeAnt5 = antenna5;
    readTimeAnt6 = antenna6;
    readTimeAnt7 = antenna7;
    readTimeAnt8 = antenna8;
    
    dispatch_async(dispatch_get_main_queue(),^{
        [self updateValue];
    });
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N receivedOuputPowerAntenna1:(uint16_t)antenna1 Antenna2:(uint16_t)antenna2
                                                        Antenna3:(uint16_t)antenna3 Antenna4:(uint16_t)antenna4
                                                        Antenna5:(uint16_t)antenna5 Antenna6:(uint16_t)antenna6
                                                        Antenna7:(uint16_t)antenna7 Antenna8:(uint16_t)antenna8
                                                             Min:(uint16_t)min Max:(uint16_t)max
{
    powerAnt1 = antenna1;
    powerAnt2 = antenna2;
    powerAnt3 = antenna3;
    powerAnt4 = antenna4;
    powerAnt5 = antenna5;
    powerAnt6 = antenna6;
    powerAnt7 = antenna7;
    powerAnt8 = antenna8;
    maxPowerValue = max;
    minPowerValue = min;
    
    if (powerAnt1 < minPowerValue) {
        powerAnt1 = minPowerValue;
    } else if (powerAnt1 > maxPowerValue) {
        powerAnt1 = maxPowerValue;
    }
    if (powerAnt2 < minPowerValue) {
        powerAnt2 = minPowerValue;
    } else if (powerAnt2 > maxPowerValue) {
        powerAnt2 = maxPowerValue;
    }
    if (powerAnt3 < minPowerValue) {
        powerAnt3 = minPowerValue;
    } else if (powerAnt3 > maxPowerValue) {
        powerAnt3 = maxPowerValue;
    }
    if (powerAnt4 < minPowerValue) {
        powerAnt4 = minPowerValue;
    } else if (powerAnt4 > maxPowerValue) {
        powerAnt4 = maxPowerValue;
    }
    if (powerAnt5 < minPowerValue) {
        powerAnt5 = minPowerValue;
    } else if (powerAnt5 > maxPowerValue) {
        powerAnt5 = maxPowerValue;
    }
    if (powerAnt6 < minPowerValue) {
        powerAnt6 = minPowerValue;
    } else if (powerAnt6 > maxPowerValue) {
        powerAnt6 = maxPowerValue;
    }
    if (powerAnt7 < minPowerValue) {
        powerAnt7 = minPowerValue;
    } else if (powerAnt7 > maxPowerValue) {
        powerAnt7 = maxPowerValue;
    }
    if (powerAnt8 < minPowerValue) {
        powerAnt8 = minPowerValue;
    } else if (powerAnt8 > maxPowerValue) {
        powerAnt8 = maxPowerValue;
    }
    dispatch_async(dispatch_get_main_queue(),^{
        [self updateValue];
    });
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N didSetOutputPowerForMultiAntenna:(ASRP31NSDKCommonStatus)statusCode
{
    /*20190621  Response Time Out*/
    [Utils hiddenLoadingView];
    switch (statusCode) {
        case ASRP31NSDKCommonStatusSuccess: {
            /*20190621  Response Time Out*/
            [Utils showLoadingView:@"Change ReadTime" timeOut:df_TIMEOUT_DEFAULT];
            
            NSError *error = [ASRP31N setReadTimeForMultiAntenna1:readTimeAnt1
                                                         Antenna2:readTimeAnt2
                                                         Antenna3:readTimeAnt3
                                                         Antenna4:readTimeAnt4
                                                         Antenna5:readTimeAnt5
                                                         Antenna6:readTimeAnt6
                                                         Antenna7:readTimeAnt7
                                                         Antenna8:readTimeAnt8];
            if( error ){
                NSLog(@"%@\n code = %ld\n%@", NSStringFromSelector(_cmd), error.code, error.userInfo);
            }
        }
            break;

        case ASRP31NSDKCommonStatusFailure:
            [Utils showAlert:@"Fail" message:@"OutPut Power  changed" view:self];
            break;

        default:
            break;
    }
}

- (void)ASRP31N:(ASRP31NSDK *)ASRP31N didSetReadTimeForMultiAntenna:(ASRP31NSDKCommonStatus)statusCode
{
    /*20190621  Response Time Out*/
   [Utils hiddenLoadingView];
    switch (statusCode) {
        case ASRP31NSDKCommonStatusSuccess:
            [Utils showAlert:@"Success" message:@"Read Time changed" view:self];
            break;
            
        case ASRP31NSDKCommonStatusFailure:
            [Utils showAlert:@"Fail" message:@"Read Time changed" view:self];
            break;
            
        default:
            break;
    }
}


- (void)ASRP31N:(ASRP31NSDK *)ASRP31N changeNetworkState:(ASRP31NSDKNetworkState)state error:(NSError *)error
{
    switch (state) {

        case ASRP31NSDKNetworkStateDisconnected:
            [Utils showAlert:@"Fail" message:@"The network connection is lost." view:self];
            break;
            
        case ASRP31NSDKNetworkStateError:
            break;
            
        default:
            break;
    }
}

@end
