//
//  TagViewController.m

#import "TagViewController.h"
#import "CustomCell.h"
#import "TagData.h"
#import "TagAccessController.h"
#import "SelectedTagInfo.h"

@interface TagViewController ()
{
    TagData *tagData;
}
@end

@implementation TagViewController

-(void) updateData
{
    dispatch_async(dispatch_get_main_queue(), ^{
        [self.tableView reloadData];
    });
}



- (void)viewDidLoad
{
    [super viewDidLoad];
    tagData = [TagData sharedInstance];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    int count = (int)[tagData.arrTags count];
    return  count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    CustomCell      *cell           = [tableView dequeueReusableCellWithIdentifier:CellIdentifier forIndexPath:indexPath];
    
   
    NSDictionary *dic = [tagData.arrTags objectAtIndex:[indexPath row]];
    
    NSString *epEpc = [dic valueForKey:df_CELL_TAG_INFO];
    NSString *count = [dic valueForKey:df_CELL_TAG_COUNT];
    NSString *ant = [dic valueForKey:df_CELL_TAG_ANT];
   
    cell.tagAnt.text                = [NSString stringWithFormat:@"ANT : %@",ant];
    cell.tagHex.text                = epEpc;
    cell.tagCount.text              = count;
    
    BOOL isRSSIOn =  [[NSUserDefaults standardUserDefaults] boolForKey:@"RSSI"];
    NSString *strRSSI  =  [dic objectForKey:df_CELL_TAG_RSSI];
    
    if((isRSSIOn)&&(strRSSI.length>0))
    {
        cell.tagRSSI.hidden  = NO;
        cell.tagRSSI.text    = [NSString stringWithFormat:@"RSSI : %@",strRSSI];
    }
    else
        cell.tagRSSI.hidden  = YES;
    
    
    BOOL isOperationMode = (BOOL)[[NSUserDefaults standardUserDefaults] boolForKey:@"OperationMode"];
    NSString *user = [dic valueForKey:df_CELL_TAG_USER];

    if((isOperationMode)&&(user.length>0))
    {
        cell.userLabel.hidden  = NO;
        cell.userLabel.text    = [NSString stringWithFormat:@"User : %@",user];
    }
    else
        cell.userLabel.hidden  = YES;
    return cell;
}

#pragma mark - Table view delegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    SelectedTagInfo *selectTag =  [SelectedTagInfo sharedInstance];
    NSDictionary *dic = [tagData.arrTags objectAtIndex:[indexPath row]];
    
    NSData* pcEpc   = [dic valueForKey:df_CELL_TAG_RAW];
    NSMutableString* tag = [[NSMutableString alloc]init] ;
    unsigned char* ptr= (unsigned char*) [pcEpc bytes];
    
    for(int i = 2; i < pcEpc.length; i++)
        [tag appendFormat:@"%02x", ptr[i] & 0xFF ];
    
    selectTag.selectedTagEPC = tag;
    
    TagAccessController *tagView = [[UIStoryboard storyboardWithName:@"Main" bundle:nil] instantiateViewControllerWithIdentifier:@"ID_TagAcessView"];
    [self.navigationController pushViewController:tagView animated:YES];
}

@end
